

global current_item = undefined
global current_item_index = undefined

database_path = (getDir #AutoBack ) + "\\MXSClip\\"
mxsclip_ini_path = database_path + "config.ini"
makedir database_path all:true


fn get_thumb_from_viewport index = (
	
	local shot_temp
	local shot_temp_scale 
	local shot_temp_filename = database_path+(index as string)+"\\mxs_cilp_pev.bmp"
	makedir (database_path+(index as string)) all:true

	
	viewport.SetShowEdgeFaces off 
	viewport.setGridVisibility 1 off

	completeredraw()
	
	shot_temp = gw.getViewportDib()
	
	scale_w = amin(#(140.0/shot_temp.width, 140.0/shot_temp.height))
	after_size = [int(shot_temp.width * scale_w), int(shot_temp.height * scale_w)]
	shot_temp_scale = bitmap after_size[1] after_size[2] color:white
	copy shot_temp shot_temp_scale 
	
	shot_temp_scale.filename = shot_temp_filename
	save shot_temp_scale

	return shot_temp_filename
	
)

fn save_selected_node index =  (
	
	local save_temp_folder = database_path+(index as string) 
	makedir (database_path+(index as string)) all:true
	
	if selection.count == 0 do(
		
		messagebox "δѡģ"
		return false
	)
	
	savenodes $ (save_temp_folder+ "\\copy.max")
	
	unkey_lst = #()
	
	for a in $ do(

		for map in (usedmaps a) do
		(
			target_filename = (save_temp_folder+"\\"+(filenamefrompath map))
				
			if finditem unkey_lst target_filename == 0 do(
				append unkey_lst target_filename
				
				try(
					copyfile map target_filename
				)catch(
					
					print target_filename
					print map
					print "ʧ"
					
					)
				
			)
				
		)
		
	)
	
	return (save_temp_folder+ "\\copy.max")
)


struct MXSClip 
(

	fn delete_all = (
		for i in 1 to 6 do(
			
			for f in getFiles (database_path+ i as string+"\\*.*") do(
				
				try(deletefile f)catch()
				
			)
			
			try(deletefile (database_path+ i as string))catch()
			
			
		)
	),
	
	fn read_ini_data index =(
		thumb_key = ("index_" + index as string + "_thumb")
		asset_key = ("index_" + index as string + "_asset")
		
		thumb = getinisetting mxsclip_ini_path "CopyData" thumb_key
		asset = getinisetting mxsclip_ini_path "CopyData" asset_key
		
		return #(thumb , asset)
	),
	
	fn save_ini_data index thumb folder=(
		
		thumb_key = ("index_" + index as string + "_thumb")
		asset_key = ("index_" + index as string + "_asset")
		
		setinisetting mxsclip_ini_path "CopyData" thumb_key thumb
		setinisetting mxsclip_ini_path "CopyData" asset_key folder
	),
	
	fn write_model widget widget_index= (
		-- дģ
		undo on (max hide inv)
		
		thumb_filename = get_thumb_from_viewport widget_index
		
		asset_filename = save_selected_node widget_index
		
		max unhide all
		
		if asset_filename != false do(
			widget.images =  #(thumb_filename, undefined,1,1,1,1,1)
			save_ini_data widget_index thumb_filename asset_filename
		)
		

	),
	
	fn read_model widget widget_index =(
		-- ȡģ
		data = (read_ini_data widget_index)
		thumb = data[1]
		asset = data[2]
		temp_path = getFilenamePath asset
		
		if thumb != "" and  doesFileExist asset then(
 
			clearselection()
			mergemaxfile asset #useSceneMtlDups #select #mergeDups

			lst = #()

			for a in $ do(
				for b in (getclassinstances bitmaptexture target:a) do(
					if finditem lst b == 0 do(
						append lst b
						
					)
				)
			)
			
			for a in lst do(
				new_filename = (temp_path + (filenamefrompath a.filename))
				if doesFileExist new_filename do(
					if maxfilepath != "" then(
						max_self_path = (maxfilepath + "\\maps\\" )
						makedir max_self_path 
						copyfile new_filename (max_self_path+(filenamefrompath a.filename))
						
						a.filename = (max_self_path+(filenamefrompath a.filename))
					)else(
							
							a.filename = new_filename
							
							)
				)
			)
		
		)else(
			write_model widget widget_index
			
			)
	),
	
	fn reload_widget widget widget_index = (
		data = (read_ini_data widget_index)
		thumb = data[1]
	
		if thumb != "" and doesFileExist thumb then(
		    widget.images =  #(thumb, undefined,1,1,1,1,1)
		)else(
			
			widget.images =  #(bitmap 200 200, undefined,1,1,1,1,1)
			)
	),
	
	fn openfolder widget widget_index = (
		
		data = (read_ini_data widget_index)
		thumb = data[1]
	
		if thumb != "" then(
		    ShellLaunch  (getFilenamePath(thumb)) ""
		)
	)
)

	
fn clicked widget = 
(
	global current_item = widget
	global current_item_index = substring (widget.name) 4 999
	
	a = MXSClip()
	a.read_model current_item current_item_index
)

fn reload widget =
(
	local current_item_index =  substring (widget.name) 4 999
	
	a = MXSClip()
	a.reload_widget widget current_item_index
	
)

fn copy_model widget =
(
	global current_item = widget
	global current_item_index = substring (widget.name) 4 999
	
	a = MXSClip()
	a.write_model current_item current_item_index
)	

fn paser_model widget =
(
	global current_item = widget
	global current_item_index = substring (widget.name) 4 999
	
	a = MXSClip()
	a.read_model current_item current_item_index
	max tool zoomextents
	
)

fn delete_all_mxs_clip=
(
	
	a = MXSClip()
	a.delete_all()
)


try(DestroyDialog (QM_MXAClip))catch()
rollout QM_MXAClip "maxƹ" width:133 height:904
(
	button refresh "ˢ" width:120 height:20 
	button delete_all "" width:120 height:20 
	
	group "1" (button copy_btn1 "ģ" width:120 height:20 toolTip:"ѡģ"; button btn1 ""  width:120 height:120)
	group "2" (button copy_btn2 "ģ" width:120 height:20 toolTip:"ѡģ"; button btn2 ""  width:120 height:120)
	group "3" (button copy_btn3 "ģ" width:120 height:20 toolTip:"ѡģ"; button btn3 ""  width:120 height:120)
	group "4" (button copy_btn4 "ģ" width:120 height:20 toolTip:"ѡģ"; button btn4 ""  width:120 height:120)
	group "5" (button copy_btn5 "ģ" width:120 height:20 toolTip:"ѡģ"; button btn5 ""  width:120 height:120)


-- 	timer tmr1 "Timer" pos:[123,59] width:24 height:24
-- 	
-- 	on tmr1 tick  do
-- 	(
-- 	
-- 		reload btn1
-- 		reload btn2
-- 		reload btn3
-- 		reload btn4
-- 		reload btn5
-- 	
-- 	
-- 	)
	
	on QM_MXAClip open do
	(		reload btn1
			reload btn2
			reload btn3
			reload btn4
			reload btn5
	)

	on refresh pressed do(
			reload btn1
			reload btn2
			reload btn3
			reload btn4
			reload btn5
		
	)
	
	on delete_all pressed do
	(
		delete_all_mxs_clip()
		reload btn1
		reload btn2
		reload btn3
		reload btn4
		reload btn5
	)
	
	on copy_btn1 pressed do
	(
		copy_model btn1
	)
	
	on btn1 pressed do
	(
		
		paser_model btn1
	)
	
	
	
	on copy_btn2 pressed do
	(
		copy_model btn2
	)
	
	on btn2 pressed do
	(
		
		paser_model btn2
	)
	
	
	on copy_btn3 pressed do
	(
		copy_model btn3
	)
	
	on btn3 pressed do
	(
		
		paser_model btn3
	)
	

	on copy_btn4 pressed do
	(
		copy_model btn4
	)
	
	on btn4 pressed do
	(
		
		paser_model btn4
	)
	

	on copy_btn5 pressed do
	(
		copy_model btn5
	)
	
	on btn5 pressed do
	(
		
		paser_model btn5
	)

	
)


createDialog QM_MXAClip style:#(#style_titlebar, #style_border, #style_sysmenu, #style_minimizebox)

cui.RegisterDialogBar QM_MXAClip
cui.DockDialogBar QM_MXAClip #cui_dock_left 	
